/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.io.*;
import java.util.*;


public class FileWrapper {

	File file;

	public String getEXT(){
		String ext = null;
		if(file.isFile()){
			String name = file.getName();
			int index = name.lastIndexOf(".");
			if(index>-1){
				return name.substring(index+1);
			}
		}
		return ext;
	}

	public FileWrapper(File file){
		this.file = file;
	}

	public void save( Object[] obj)throws Exception {
		BufferedWriter writer = new BufferedWriter(new FileWriter(file));
		for(int i=0;i<obj.length;i++){
			writer.write(obj[i].toString());
			writer.newLine();
		}
		writer.flush();
		writer.close();
	}

	public void save(Object obj)throws Exception {
		save(obj.toString());
	}

	public void save(byte[] data)throws Exception {
		BufferedOutputStream out=new BufferedOutputStream(new FileOutputStream(file));
		out.write(data);
		out.flush();
		out.close();
	}

	public void save(String data)throws Exception{
		
		BufferedWriter writer = new BufferedWriter(new FileWriter(file));
		writer.write(data);	
		writer.flush();
		writer.close();
		

	
	}

	public String open()throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(file));
		StringBuffer buffer = new StringBuffer();
		for (String tmp; (tmp = reader.readLine()) != null; ) {
			buffer.append(tmp);
			buffer.append("\n");
		}
		return buffer.toString();
	}
}
