/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.JFileChooser;


public class GooglePatentGrabberFrame extends Frame implements ActionListener {

	TextField textfield1;
	
	
	Choice choice3;
	Choice choice4;

	JFileChooser filechooser;

	Checkbox checkbox1;
	Checkbox checkbox2;



	public GooglePatentGrabberFrame() {
		super("Google Patent Grabber");
		this.setSize(400, 200);
		this.setLayout(null);
		addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent e) { System.exit(0); } });

		filechooser = new JFileChooser(new File(System.getProperty("user.dir")));
		 

		textfield1 = new TextField();
		textfield1.setBounds(10, 30, 200, 20);
		add(textfield1);

		Button button1 = new Button("Search & Grab");
		button1.setBounds(250, 30, 100, 20);
		button1.addActionListener(this);
		add(button1);


		Label label0 = new Label("Recurrent Levels:");
		label0.setBounds(10, 105, 100, 20);
		add(label0);

	
		Label label3 = new Label("Forward Citations (descendants):");
		label3.setBounds(10, 130, 200, 20);
		add(label3);

		choice3 = new Choice();
		choice3.setBounds(210, 130, 50, 20);
		add(choice3);


		Label label4 = new Label("Backward Citations (ancestors):");
		label4.setBounds(10, 155, 200, 20);
		add(label4);

		choice4 = new Choice();
		choice4.setBounds(210, 155, 50, 20);
		add(choice4);

		checkbox1 = new Checkbox("PDF", false);
		checkbox1.setBounds(10, 55, 200, 20);
		add(checkbox1);

		checkbox2 = new Checkbox("Family (esp@cenet)", false);
		checkbox2.setBounds(10, 80, 200, 20);
		add(checkbox2);


		for (int i = 0; i < 10; i++) {
			choice3.addItem(String.valueOf(i));
			choice4.addItem(String.valueOf(i));
		}

		this.setResizable(false);
		this.setVisible(true);

	}

	
	public void actionPerformed(ActionEvent event) {

		try {

			Button button = (Button)event.getSource();
						

			if (button.getLabel().equals("Search & Grab")){

				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir=filechooser.getSelectedFile();

				if (dir!= null){


					
					int FC_depth = Integer.parseInt(choice3.getSelectedItem());
					int BC_depth = Integer.parseInt(choice4.getSelectedItem());

									
					boolean grabPdf = checkbox1.getState();
					boolean grabFamily = checkbox2.getState();


					GooglePatentGrabber grabber = new GooglePatentGrabber(textfield1.getText(), dir, FC_depth, BC_depth, grabPdf, grabFamily);

					new Thread(grabber).start();
					
				}
			}



			
		}
		catch (Exception e) {
			e.printStackTrace();
		}



	}
}
