/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.awt.*;
import java.awt.event.*;

public class GraphFrame extends Frame implements ActionListener,WindowListener{
	
	GraphPanel panel;
	
	public void windowActivated(WindowEvent e){}
	public void windowDeactivated(WindowEvent e) { }
	public void windowClosed(WindowEvent e) { }
	public void windowClosing(WindowEvent e){
		panel.stop();
		setVisible(false);
		this.dispose();
	}
	public void windowIconified(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowOpened(WindowEvent e) { }
	
	public GraphFrame(String title,GraphPanel panel) {
		super(title);
		setLayout(new BorderLayout());
		setSize(640, 480);

		addWindowListener(this);

		MenuBar menubar = new MenuBar();
		Menu menu = new Menu("Dynamics");
		MenuItem menuitem = new MenuItem("Relax");
		menuitem.addActionListener(this);
		menu.add(menuitem);
		
		menuitem = new MenuItem("Wall");
		menuitem.addActionListener(this);
		menu.add(menuitem);

		menuitem = new MenuItem("Center");
		menuitem.addActionListener(this);
		menu.add(menuitem);

		menuitem = new MenuItem("Spring");
		menuitem.addActionListener(this);
		menu.add(menuitem);


		menuitem = new MenuItem("Repulsion");
		menuitem.addActionListener(this);
		menu.add(menuitem);

		menuitem = new MenuItem("Gravity");
		menuitem.addActionListener(this);
		menu.add(menuitem);

		menubar.add(menu);
		this.setMenuBar(menubar);

		this.panel = panel;
		add("Center", panel);
		setVisible(true);
		panel.start();

	}
		

	public void actionPerformed(ActionEvent e){
		MenuItem mi=(MenuItem)e.getSource();
		//System.out.println(mi.getLabel());
		if(mi.getLabel().equals("Relax")){
			panel.relax = !panel.relax;
		}

		if (mi.getLabel().equals("Wall")) {
			panel.wall  = !panel.wall;
		}

		if (mi.getLabel().equals("Center")) {
			panel.force_center = !panel.force_center;
		}

		if (mi.getLabel().equals("Spring")) {
			panel.spring = !panel.spring;
		}

		if (mi.getLabel().equals("Repulsion")) {
			panel.repulsion = !panel.repulsion;
		}

		if (mi.getLabel().equals("Gravity")) {
			panel.gravity = !panel.gravity;
		}
	}

}
