/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.util.*;


public class KeywordCounter {
	
		
	static String Filter(String string) {
		StringBuffer sb = new StringBuffer();
		if (string != null) {
			for (int i = 0; i < string.length(); i++) {
				char c = string.charAt(i);
				if (Character.isLetter(c)) {
					sb.append(c);
				}
				else {
					sb.append(" ");
				}
			}
		}
		return sb.toString().toLowerCase();
	}

	public static Countee[] count(String[] Articles){
		Hashtable H1 = new Hashtable();
		//String[] stopwords ={ "a", "the", "and", "or", "but", "is", "can", "would", "not", "be" };

		for (int i = 0; i < Articles.length; i++) {
			Hashtable H2 = new Hashtable();
			StringTokenizer tokenizer = new StringTokenizer(Filter(Articles[i]));
			while (tokenizer.hasMoreTokens()) {
				String keyword = tokenizer.nextToken();
				if (H2.get(keyword) == null) {
					H2.put(keyword, keyword);
				}
			}
			Enumeration enu = H2.elements();
			while (enu.hasMoreElements()) {
				String keyword = (String)enu.nextElement();
				Countee countee;

				if ((countee = (Countee)H1.get(keyword)) != null) {
					countee.count++;
				}
				else {
					H1.put(keyword, new Countee(keyword));
				}
			}
		}

		Countee[] C=new Countee[H1.size()];
		Enumeration enu = H1.elements();
		for(int i=0;enu.hasMoreElements();i++){
			C[i] = (Countee)enu.nextElement();
		}
		Arrays.sort(C);
		
		return C;

	}

}
