/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;



public class Patent {

	String TTL;//Title
	String ABST;//Abstract
	String PN;//Patent number
	String APD;//Filed date
	String ISD;//Issued date
	String[] IN;//Inventors
	String AN;//Assignee
	String ACLM;//Claims

	String[] ReferencedBy;
	String[] Citations;

	public String[] getCitations(){
		return Citations;
	}

	public String[] getReferencedBy(){
		return ReferencedBy;
	}

	public String getIN(){
		StringBuffer buffer = new StringBuffer();
		if (IN != null) {
			for (int i = 0; i < IN.length - 1; i++) {
				buffer.append(IN[i] + " ,");
			}
			buffer.append(IN[IN.length - 1]);
		}

		return buffer.toString();
		
	}


	public String[] getINs() {
		

		return IN;

	}

	public String getAN() {
		if (AN != null) {
			return AN;
		} else {
			return "";
		}
	}

	public String getACLM(){
		if (ACLM != null) {
			return ACLM;
		} else {
			return "";
		}
	}

	public String getTTL() {
		return TTL;
	}

	public String getABST(){
		
		if(ABST!=null){
			return ABST;
		}else{
			return "";
		}
	}

	public String getPN(){
		return PN;
	}

	public String getAPD() {
		return APD;
	}

	public String getISD() {
		return ISD;
	}

	
	public String toString(){
		StringBuffer buffer = new StringBuffer();
		buffer.append(PN+"\t"+TTL+"\t"+APD+"\t"+ISD+"\t");
		buffer.append(getIN() + "\t");
		buffer.append(getAN()+"\t");

		
		for (int i = 0; i < Citations.length - 1; i++) {
			buffer.append(Citations[i] + ",");
		}
		if (Citations.length>0){
			buffer.append(Citations[Citations.length - 1] + "\t");
		}


		for (int i = 0; i < ReferencedBy.length - 1; i++) {
			buffer.append(ReferencedBy[i] + ",");
		}
		if (ReferencedBy.length>0){
			buffer.append(ReferencedBy[ReferencedBy.length - 1] + "\t");
		}
		

		buffer.append(getABST().replace('\n',' ')+"\t");
		buffer.append(getACLM().replace('\n', ' '));
		return buffer.toString();
	}
}
