/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.JFileChooser;


public class PatentAnalyzerFrame extends Frame implements ActionListener {

	
	JFileChooser filechooser;


	public PatentAnalyzerFrame() {
		super("Patent Analyzer");
		this.setSize(400, 200);
		this.setLayout(null);
		addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent e) { System.exit(0); } });

		filechooser = new JFileChooser(new File(System.getProperty("user.dir")));

		
		Button button2 = new Button("PN network");
		button2.setBounds(220, 90, 75, 20);
		button2.addActionListener(this);
		add(button2);

		Button button3 = new Button("IN network");
		button3.setBounds(220, 120, 75, 20);
		button3.addActionListener(this);
		add(button3);

		Button button4 = new Button("AN network");
		button4.setBounds(220, 150, 75, 20);
		button4.addActionListener(this);
		add(button4);

		Button button5 = new Button("List All");
		button5.setBounds(50, 60, 75, 20);
		button5.addActionListener(this);
		add(button5);


		Button button6 = new Button("EndNote");
		button6.setBounds(135, 60, 75, 20);
		button6.addActionListener(this);
		add(button6);	


		Button button8 = new Button("Keywords");
		button8.setBounds(50, 90, 75, 20);
		button8.addActionListener(this);
		add(button8);

		Button button9 = new Button("Sort by FC");
		button9.setBounds(50, 120, 75, 20);
		button9.addActionListener(this);
		add(button9);

		Button button10 = new Button("Sort by Family");
		button10.setBounds(50, 150, 75, 20);
		button10.addActionListener(this);
		add(button10);


	
		this.setResizable(false);
		this.setVisible(true);
	}

	
	public void actionPerformed(ActionEvent event) {

		try {

			Button button = (Button)event.getSource();


			if (button.getLabel().equals("List All")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();


				
				if (dir != null) {

					String content = new PatentAnalyzer(dir).toString();
					new TextAreaFrame(dir.getName(), content);


					filechooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
					filechooser.setSelectedFile(new File("list.txt"));
					filechooser.showSaveDialog(this);
					File export = filechooser.getSelectedFile();

					if (export != null) {
						new FileWrapper(export).save(content);
					}
				}


		
			}

			if (button.getLabel().equals("EndNote")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				
				if (dir != null) {

					String content = new PatentAnalyzer(dir).toEndNote();
					new TextAreaFrame(dir.getName(), content);


					filechooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
					filechooser.setSelectedFile(new File("list.ciw"));
					filechooser.showSaveDialog(this);
					File export = filechooser.getSelectedFile();

					if (export != null) {
						new FileWrapper(export).save(content);
					}
				}


			

			}
			
			if (button.getLabel().equals("PN network")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {

					new PatentAnalyzer(dir).genCitationsNetworkPN();
				}
			}

			if (button.getLabel().equals("AN network")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {

					new PatentAnalyzer(dir).genCitationsNetworkAN();
				}
			}

			if (button.getLabel().equals("IN network")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {

					new PatentAnalyzer(dir).genCitationsNetworkIN();
				}
			}

			if (button.getLabel().equals("Keywords")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {
					new TextAreaFrame(dir.getName(), new PatentAnalyzer(dir).sortKeywords());
				}
			}

			if (button.getLabel().equals("Sort by FC")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {
					new TextAreaFrame(dir.getName(), new PatentAnalyzer(dir).sortReferencedBy());
				}
			}

			if (button.getLabel().equals("Sort by Family")) {
				filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				filechooser.showOpenDialog(this);
				File dir = filechooser.getSelectedFile();

				if (dir != null) {
					new TextAreaFrame(dir.getName(), new PatentAnalyzer(dir).sortFamily());
				}
			}
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}



	}
}
