/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.net.*;
import java.io.*;

public abstract class PatentGrabber {

	String cookie;

	public abstract void initCookie()throws Exception;

	public static String to2(String s) {
		while (s.length() < 2) {
			s = "0" + s;
		}
		return s;
	}

	public byte[] getResponseBytes(String url) {
		ByteArrayOutputStream out = new ByteArrayOutputStream();

		try {
			System.out.println(url);

			HttpURLConnection urlConn = (HttpURLConnection)new URL(url).openConnection();
			urlConn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows 2000)");

			if (cookie != null) {
				urlConn.setRequestProperty("Cookie", cookie);
			}


			BufferedInputStream in = new BufferedInputStream(urlConn.getInputStream());
			
			byte[] buffer = new byte[1024*1024];

			for (int i; (i = in.read(buffer)) > 0; ) {
				out.write(buffer, 0, i);
			}
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return out.toByteArray();
	}

	public String getResponseString(String url) {
		StringBuffer sb = new StringBuffer();
		try {

			System.out.println(url);
			HttpURLConnection urlConn = (HttpURLConnection)new URL(url).openConnection();

			urlConn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows 2000)");

			if (cookie != null) {
				urlConn.setRequestProperty("Cookie", cookie);
			}

			if (urlConn.getHeaderField("Set-Cookie") != null) {
				cookie = urlConn.getHeaderField("Set-Cookie");
			}

			
			BufferedReader br = new BufferedReader(new InputStreamReader(urlConn.getInputStream()));
			for (String tmp; (tmp = br.readLine()) != null; ) {
				sb.append(tmp);
			}


			
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return sb.toString();
	}

}
