/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.io.*;
import java.net.*;

public class URLConnectionWrapper {

	URLConnection urlConn;

	public URLConnectionWrapper(URLConnection urlConn){
		this.urlConn = urlConn;
	}
		
	public void sendString(String string)throws Exception {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(urlConn.getOutputStream()));
		bw.write(string);
		bw.flush();
		bw.close();
	}

	

	public String getStringUTF8()throws Exception {

		BufferedReader br = new BufferedReader(new InputStreamReader(urlConn.getInputStream(), "UTF8"));
		StringBuffer sb = new StringBuffer();
		for (String tmp; (tmp = br.readLine()) != null; ) {
			sb.append(tmp);
		}

		return sb.toString();
	}

	public static String deTag(String string) {
		String new_string = null;
		if (string != null) {
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < string.length(); i++) {
				char c = string.charAt(i);
				if (c == '<') {
					while ((c = string.charAt(++i)) != '>') {
						buffer.append(" ");
					}
				}
				else {
					if (c == 32 || c == 9 || c == 12288 || c == 10 || c == 13) {
						buffer.append(" ");
					}
					else {
						buffer.append(c);
					}
				}
			}
			new_string= buffer.toString();
		}

		return new_string;
		
	}


	public static String deTag_(String string) {

		String new_string = null;
		
		if (string != null) {
			StringBuffer sb = new StringBuffer();
			for (int i = 0; i < string.length(); i++) {

				char c = string.charAt(i);

				switch (c) {
					case '<':
						while ((c = string.charAt(++i)) != '>') { }
						sb.append(" ");
						break;

					case '&':

						StringBuffer sbb = new StringBuffer();
						sbb.append(c);
						sbb.append(string.charAt(++i));
						sbb.append(string.charAt(++i));
						sbb.append(string.charAt(++i));
						sbb.append(string.charAt(++i));
						sbb.append(string.charAt(++i));
						String tmp = sbb.toString();
						if (tmp.equalsIgnoreCase("&nbsp;")) {
						} else {
							sb.append(tmp);
						}
						break;

					case 9:
					case 10:
					case 13:
					case 32:
					case 12288:
						sb.append(" ");
						break;
					default:
						sb.append(c);
				}
			}
			new_string = sb.toString();
		}
		return new_string;
		
	}


}
