/*
Copyright (C) 2008 Chen Shih Sheng (shih.sheng@msa.hinet.net)

This file is part of PatentNet.

PatentNet is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PatentNet is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PatentNet.  If not, see <http://www.gnu.org/licenses/>.

*/

package PatentNet;

import java.io.*;
import java.net.*;
import java.util.*;

public class usptoPatentGrabber extends PatentGrabber {

	File dir;
	Date min_date;
	Date max_date;

	public void nextDate() {
		int y = min_date.getYear();
		int m = min_date.getMonth();
		int d = min_date.getDate();
		min_date = new Date(y, m, d + 1);
	}
		

	public void grabDayByDay()throws Exception {
		while ((max_date.getTime() - min_date.getTime()) >= 0) {
			//System.out.println(min_date);
			int y = min_date.getYear();
			int m = min_date.getMonth() + 1;
			int d = min_date.getDate();

			File subdir = new File(dir, String.valueOf(y));
			if(!subdir.exists()){
				subdir.mkdir();
			}
			subdir = new File(subdir, StringUtils.to2(m));
			if (!subdir.exists()) {
				subdir.mkdir();
			}
			String ISD = y + StringUtils.to2(m) + StringUtils.to2(d);
			File file = new File(subdir, ISD + ".txt");
			
			if (!file.exists()) {

				
				String[] PNs = parsePNs(ISD);


				if (PNs.length > 0) {
					new FileWrapper(file).save(PNs);
				}
			}
			nextDate();
		}
	}

	public usptoPatentGrabber(File dir, Date min_date, Date max_date)throws Exception {
		this.min_date = min_date;
		this.max_date = max_date;
		this.dir = dir;
	}


	public String[] parsePNs(String date)throws Exception {
		Vector Patents = new Vector();

		for (int i = 1; ; i++) {

			String result = qd(date, i);

			if (result == null) {
				break;
			}

			if (result.indexOf("Error #2000") > -1) {
				break;
			}

			if (result.indexOf("No patents have matched your query") > -1) {
				break;
			}


			for (int j; (j = result.indexOf("<A  HREF=/netacgi/nph-Parser?")) > -1; ) {
				result = result.substring(j);
				int k = result.indexOf(">");
				result = result.substring(k + 1);
				int m = result.indexOf("<");
				String PN = result.substring(0, m).trim();
				if (Character.isDigit(PN.charAt(PN.length() - 1))) {
					Patents.add(PN);
				}
			}
		}

		String[] PNs = new String[Patents.size()];
		Patents.toArray(PNs);
		return PNs;
	}

	public String qd(String date, int nextlist) {
		//PALL or PTXT
		String url = "http://patft.uspto.gov/netacgi/nph-Parser?Sect1=PTO2&Sect2=HITOFF&u=%2Fnetahtml%2FPTO%2Fsearch-adv.htm&r=0&f=S&l=50&d=PALL&OS=isd%2F";
		url += date;
		url += "&RS=ISD%2F";
		url += date;
		url += "&Query=isd%2F";
		url += date;
		url += "&Srch1=";
		url += date;
		url += ".PD.&NextList";
		url += String.valueOf(nextlist);
		url += "=Next+50+Hits";

		return getResponseString(url);
	}

	public void initCookie()throws Exception {
		URL url = new URL("http://patft.uspto.gov");
		HttpURLConnection urlConn = (HttpURLConnection)url.openConnection();
		urlConn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows 2000)");

		if (urlConn.getHeaderField("Set-Cookie") != null) {
			cookie = urlConn.getHeaderField("Set-Cookie");
		}
	}
}
